unit UFMain;

interface

{$I jedi.inc}

uses
  System.SysUtils, System.Types, System.UITypes, System.Classes,
  System.Variants,
  FMX.Types, FMX.Graphics, FMX.Controls, FMX.Forms, FMX.Dialogs, FMX.TabControl,
  FMX.StdCtrls, FMX.Gestures, FMX.Controls.Presentation, FMX.MultiView,
  FMX.ListBox, FMX.Layouts, FMX.Objects, FMX.Edit, IdBaseComponent, IdComponent,
  IdTCPConnection, IdTCPClient, IdHTTP, FMX.ScrollBox, FMX.Memo,
  {uLkJSON,} UTWeatherClass, JSON, IniFiles, FMX.Effects, FrHoras;

type
  TFormMain = class(TForm)
    HeaderToolBar: TToolBar;
    ToolBarLabel: TLabel;
    TabControl1: TTabControl;
    tsAnyadir: TTabItem;
    tsInfo: TTabItem;
    tsAcercaDe: TTabItem;
    GestureManager1: TGestureManager;
    MultiView1: TMultiView;
    ListBox1: TListBox;
    MasterButton: TSpeedButton;
    btnAnyadir1: TButton;
    btnAcerca1: TButton;
    btnRefrescar1: TButton;
    btnAnyadir2: TButton;
    btnAcerca2: TButton;
    btnRefrescar2: TButton;
    StyleBook1: TStyleBook;
    Panel2: TPanel;
    Label3: TLabel;
    lbCiudades: TListBox;
    tsCiudades: TTabItem;
    Panel1: TPanel;
    lbCiudadesDisp: TListBox;
    btnCiudades: TButton;
    btnCiudades2: TButton;
    IdHTTP: TIdHTTP;
    tsDebug: TTabItem;
    mmData: TMemo;
    Label2: TLabel;
    btnDebug1: TButton;
    btnDebug2: TButton;
    Panel3: TPanel;
    Panel4: TPanel;
    lblCiudad: TLabel;
    imgTiempo: TImage;
    lblNuves: TLabel;
    lblTempMax: TLabel;
    lblTemp: TLabel;
    lblTempMin: TLabel;
    ScrollBox1: TScrollBox;
    rectAbout: TRectangle;
    Image4: TImage;
    Label4: TLabel;
    Label5: TLabel;
    Label6: TLabel;
    Memo1: TMemo;
    ShadowEffect2: TShadowEffect;
    Label7: TLabel;
    btnCloseAbout: TButton;
    ListBoxItem1: TListBoxItem;
    Panel5: TPanel;
    btnEliminar: TButton;
    frHora0: TFrameHoras;
    frHora1: TFrameHoras;
    frHora4: TFrameHoras;
    frHora2: TFrameHoras;
    Panel6: TPanel;
    lblProxHoras: TLabel;
    edtNombreCiudad: TEdit;
    BlurEffect1: TBlurEffect;
    BlurEffect2: TBlurEffect;
    AniIndicator1: TAniIndicator;
    AniIndicator2: TAniIndicator;
    btnBuscar: TButton;
    btnNueva: TButton;
    Panel7: TPanel;
    Label1: TLabel;
    edtCiudad: TEdit;
    btnSearch: TButton;
    Button1: TButton;
    frHora6: TFrameHoras;
    frHora5: TFrameHoras;
    FrHora3: TFrameHoras;
    frHora7: TFrameHoras;
    procedure FormCreate(Sender: TObject);
    procedure FormGesture(Sender: TObject; const EventInfo: TGestureEventInfo;
      var Handled: Boolean);
    procedure FormShow(Sender: TObject);
    procedure btnAnyadir1Click(Sender: TObject);
    procedure btnAcerca1Click(Sender: TObject);
    procedure btnCiudadesClick(Sender: TObject);
    procedure btnSearchClick(Sender: TObject);
    procedure Button1Click(Sender: TObject);
    procedure edtCiudadKeyDown(Sender: TObject; var Key: Word;
      var KeyChar: Char; Shift: TShiftState);
    procedure btnAhoraClick(Sender: TObject);
    procedure btnDebug1Click(Sender: TObject);
    procedure btnProxHorasClick(Sender: TObject);
    procedure frHora0Click(Sender: TObject);
    procedure btnRefrescar1Click(Sender: TObject);
    procedure lbCiudadesItemClick(const Sender: TCustomListBox;
      const Item: TListBoxItem);
    procedure btnBuscarClick(Sender: TObject);
    procedure btnNuevaClick(Sender: TObject);
    procedure btnCloseAboutClick(Sender: TObject);
    procedure ScrollBox1Click(Sender: TObject);
  private
    FResponse: string;
    objResp: {$IFDEF DELPHIXE_UP}TJSONObject{$ELSE}TlkJSONobject{$ENDIF};
    errCode: integer;
    errMsg: string;
    ConfigFile, CiudadesFile:TIniFile;

    // Obtiene la respuesta JSON formateada
    function GetFormattedResponse(AResponse: String): string;
    // Obtener la lista de ciudades de un consulta
    function ParseCiudades(AObjResp:TJSONObject; var AListaCiudades: TListaCiudades): Boolean;
    // Parsea la respuesta de varias ciudades a una estructura que nos ha devuelto la web
    function ParseTiempoCiudades(AObjResp:TJSONObject; var ATiempoObj:TTiempoStruct):Boolean;
    function ParseTiempoCiudadesHist(AObjResp:TJSONobject; var ATiempoProxHoras:TTiempoProxHoras):Boolean;
    // actulizar en pantalla el tiempo de una ciudad
    function ActualizarInfoCiudad(ATiempoObj: TTiempoStruct):boolean;
    procedure ActualizarInfoTiempo(ATiempoProxHoras:TTiempoProxHoras);
    // actualizar el frame con la informacin
    procedure ActualizarFrameHoras(AFrame:TFrameHoras; ATiempoProxHora:TTiempoProxHora);

    // busca informacin de una ciudad
    procedure BuscarInfoCiudad(sCiudad:string);
    // busca informacin de una ciudad para varios das
    procedure BuscarInfoCiudadDias(sCiudad:string);

    //: recupara la imagen y la guarda en disco
    procedure DownloadImage(URLImage:string; APath:string);

    // Fchero de Log
    function GetLogFileName():string;
    function GetConfigFileName():string;
    function GetCiudadesFileName():string;
    procedure _Log(AMsg:string);

    procedure GrabarCiudades();

  public
    { Public declarations }
  end;

var
  FormMain: TFormMain;

// Cabeceras de funciones
function GetJSONPairItemFloat(JSONPair:TJSONPair; AValueName:string):Double;
function GetJSONPairItemString(JSONPair:TJSONPair; AValueName:string):string;


implementation

{$I jedi.inc}
{$R *.fmx}
{$R *.LgXhdpiPh.fmx ANDROID}
{$R *.NmXhdpiPh.fmx ANDROID}
{$R *.iPhone47in.fmx IOS}
{$R *.iPhone.fmx IOS}

uses
{$IFDEF DELPHIXE_UP}
  System.StrUtils, System.IOUtils,
  FMX.MediaLibrary, System.DateUtils,
{$ENDIF}
  UConstantes, UProcedures;

{rocedure PNGFileToBitmap(const Source:string; var ABitmap:TBitmap); overload;
var
  PNG: TPNGObject;
begin
  PNG := TPNGObject.Create;
  try
    PNG.LoadFromFile(Source);
    ABitmap.Assign(PNG);    //Convert data into bitmap
    // ABitmap.SaveToFile(Dest);
  finally
    PNG.Free;
  end
end;
}

{rocedure PNGFileToBitmap(const Source, Dest: String); overload;
var
  Bitmap: TBitmap;
  PNG: TPNGObject;
begin
  PNG := TPNGObject.Create;
  Bitmap := TBitmap.Create;
  // case something goes wrong, free booth PNG and Bitmap
  try
    PNG.LoadFromFile(Source);
    Bitmap.Assign(PNG);    //Convert data into bitmap
    Bitmap.SaveToFile(Dest);
  finally
    PNG.Free;
    Bitmap.Free;
  end
end;
}


// busca informacin de una ciudad para varios das
procedure TFormMain.BuscarInfoCiudadDias(sCiudad: string);
var
  Str, StrW:String;
  ATiempoProxHoras:TTiempoProxHoras;
  AForecastData:TForecastStruct;
begin
  _Log('+TFormMain.BuscarInfoCiudadDias');
  // Ini                    // proximos 14 das...
  try
    Str := AnsiReplaceText(sCiudad, CHAR_SPACE, '%20');
    _Log('  Str: ' + Str);
    StrW := Format(URL_SEARCH_CITY_VARIOS,[UTF8Encode(Str)]) + STR_APPID;
    StrW := Format(URL_SEARCH_CITY_VARIOS,[Str]) + STR_APPID;
    _log('   StrW: ' + StrW);
    _Log('   Antes de la peticion (get)');
    Self.FResponse := Self.IdHTTP.Get(StrW);
    _log('   Respuesta: ' + Self.FResponse);
  except
    on E:Exception do begin
      _Log('ERROR: ' + E.Message);
      MessageDlg('Error:' + E.Message, TMsgDlgType.mtError, [TMsgDlgBtn.mbOK], 0);
    end;
  end;

  // Hacer un parse de la respuesta
  mmData.Lines.Add(GetFormattedResponse(Self.FResponse));

  _Log('+ Crear objeto JSON con la respuesta');
	// Hacer un parse de la respuesta
  objResp := TJSONObject.ParseJSONValue
    (TEncoding.ASCII.GetBytes(Self.FResponse), 0) as TJSONObject;
  _Log('- Crear objeto JSON con la respuesta');

	// parsear la respuesta
  ParseTiempoCiudadesHist(objResp, ATiempoProxHoras);
  // Actualizar datos en pantalla
  ActualizarInfoTiempo(ATiempoProxHoras);

  _Log('-TFormMain.BuscarInfoCiudad');
end;


procedure TFormMain.btnProxHorasClick(Sender: TObject);
begin
  // activar la pestaa
  TabControl1.ActiveTab := tsInfo;
  Application.ProcessMessages;
  // Indicador
  BlurEffect2.Enabled := true;
  AniIndicator2.Visible := True;
  AniIndicator2.Enabled := True;
  Application.ProcessMessages;
  // proteccion para acabar
  try

    _Log('+ BuscarInfoCiudadDias');
    BuscarInfoCiudadDias(edtNombreCiudad.Text);
    _Log('- BuscarInfoCiudadDias');

  finally
    AniIndicator2.Enabled := False;
    AniIndicator2.Visible := False;
    BlurEffect2.Enabled := False;
  end;
end;

procedure TFormMain.btnAcerca1Click(Sender: TObject);
begin
  TabControl1.ActiveTab := tsAcercaDe;
  MultiView1.HideMaster;
end;

procedure TFormMain.btnAnyadir1Click(Sender: TObject);
begin
  TabControl1.ActiveTab := tsAnyadir;
  MultiView1.HideMaster;
end;

procedure TFormMain.btnBuscarClick(Sender: TObject);
var
  str:String;
begin
  Str := lbCiudadesDisp.Selected.Text;
  edtNombreCiudad.Text := Str;

  // Buscar el actual
  btnAhoraClick(nil);
  // Buscar los prximos
  btnProxHorasClick(nil);

end;

procedure TFormMain.btnCiudadesClick(Sender: TObject);
begin
  TabControl1.ActiveTab := tsCiudades;
  MultiView1.HideMaster;
end;





procedure TFormMain.btnCloseAboutClick(Sender: TObject);
begin
  TabControl1.ActiveTab := tsInfo;
end;

procedure TFormMain.btnDebug1Click(Sender: TObject);
begin
  TabControl1.ActiveTab := tsDebug;
end;

procedure TFormMain.btnNuevaClick(Sender: TObject);
begin
  // cambiar de pestaa
  TabControl1.ActiveTab := tsAnyadir;
  edtCiudad.SetFocus;
end;

procedure TFormMain.btnRefrescar1Click(Sender: TObject);
begin
  TabControl1.ActiveTab := tsInfo;
  MultiView1.HideMaster;



end;

procedure TFormMain.btnSearchClick(Sender: TObject);
var
  Str, StrW: String;
  AForecastData: TForecastStruct;
  lCiudades: TListaCiudades;
  I: integer;
begin
  // proximos 14 das...
  try
    Str := AnsiReplaceText(edtCiudad.Text, CHAR_SPACE, '%20');
    StrW := Format(URL_SEARCH_CITIES, [UTF8Encode(Str)]) + STR_APPID;
    StrW := Format(URL_SEARCH_CITIES, [Str]) + STR_APPID;
    Self.FResponse := Self.IdHTTP.Get(StrW);
  except
    on E: Exception do
    begin
      MessageDlg('Error:' + E.Message, TMsgDlgType.mtError,  [TMsgDlgBtn.mbOK], 0);
    end;
  end;
  // Hacer un parse de la respuesta
  mmData.Lines.Add(GetFormattedResponse(Self.FResponse));

  // Hacer un parse de la respuesta
  objResp := TJSONObject.ParseJSONValue
    (TEncoding.ASCII.GetBytes(Self.FResponse), 0) as TJSONObject;

  // parsear la respuesta
  ParseCiudades(objResp, lCiudades);
  // Actualizar las ciudades encontradas
  lbCiudades.Clear;
  // Hay alguna?
  if (lCiudades.cont > 0) then begin
    for I := 0 to (lCiudades.cont - 1) do  begin
      lbCiudades.Items.Add(lCiudades.ciudades[I].nombre + ', ' + lCiudades.ciudades[I].pais);
    end;
  end;

  TabControl1.ActiveTab := tsAnyadir;
  lbCiudades.SetFocus;

end;

// busca informacin de una ciudad
procedure TFormMain.BuscarInfoCiudad(sCiudad: string);
var
  StrW, Str:String;
  ATiempoData:TTiempoStruct;
begin
  _Log('+TFormMain.BuscarInfoCiudad');
  // Ini
	// realizar el envo
  try
    Str := AnsiReplaceText(sCiudad, CHAR_SPACE, '%20');
    _Log('  Str: ' + Str);
    StrW := Format(URL_SEARCH_CITY,[UTF8Encode(Str)]) + STR_APPID;
    StrW := Format(URL_SEARCH_CITY,[Str]) + STR_APPID;
    _log('   StrW: ' + StrW);
    _Log('   Antes de la peticion (get)');
    Self.FResponse := Self.IdHTTP.Get(StrW);
    _log('   Respuesta: ' + Self.FResponse);
  except
    on E:Exception do begin
      _Log('ERROR: ' + E.Message);
      MessageDlg('Error:' + E.Message, TMsgDlgType.mtError, [TMsgDlgBtn.mbOK], 0);
    end;
  end;

  // Hacer un parse de la respuesta
  mmData.Lines.Add(GetFormattedResponse(Self.FResponse));

  _Log('+ Crear objeto JSON con la respuesta');
	// Hacer un parse de la respuesta
  objResp := TJSONObject.ParseJSONValue
    (TEncoding.ASCII.GetBytes(Self.FResponse), 0) as TJSONObject;
  _Log('- Crear objeto JSON con la respuesta');

	// parsear la respuesta
  ParseTiempoCiudades(objResp, ATiempoData);
  // Actualizar datos en pantalla
  ActualizarInfoCiudad(ATiempoData);

  _Log('-TFormMain.BuscarInfoCiudad');
end;


procedure TFormMain.Button1Click(Sender: TObject);
var
  index: integer;
begin
  index := lbCiudadesDisp.Selected.Index;
  lbCiudades.Items.Delete(index);
end;

procedure TFormMain.btnAhoraClick(Sender: TObject);
begin
  // activar la pestaa
  TabControl1.ActiveTab := tsInfo;
  Application.ProcessMessages;
  // Indicador
  BlurEffect1.Enabled := true;
  BlurEffect2.Enabled := true;

  AniIndicator1.Visible := True;
  AniIndicator1.Enabled := True;
  Application.ProcessMessages;
  // proteccion para acabar
  try

    _Log('+ BuscarInfoCiudad');
    BuscarInfoCiudad(edtNombreCiudad.Text);
    _Log('- BuscarInfoCiudad');

  finally
    AniIndicator1.Enabled := False;
    AniIndicator1.Visible := False;
    BlurEffect1.Enabled := False;
  end;
end;

procedure TFormMain.edtCiudadKeyDown(Sender: TObject; var Key: Word;
  var KeyChar: Char; Shift: TShiftState);
begin
  if (Key = 13) then begin
    btnSearchClick(nil);
  end;
end;

procedure TFormMain.FormCreate(Sender: TObject);
var
  fName:string;
  TS:TStrings;
  I: Integer;
begin
  { This defines the default active tab at runtime }
  TabControl1.ActiveTab := tsAnyadir;
  // Fichero de log y de ciudades
  fName := GetConfigFileName();
  ConfigFile := TIniFile.Create(fName);
  fName := GetCiudadesFileName();
  CiudadesFile := TIniFile.Create(fName);

  // Si esiste, cargamos las ciudades
  if FileExists(fName) then begin
    TS := TStringList.Create;
    CiudadesFile.ReadSectionValues('CIUDADES', TS);
    // Cargar las ciudades
    lbCiudadesDisp.Items.Clear;
    for I := 0 to (TS.Count - 1) do begin
      lbCiudadesDisp.Items.Add(TS.ValueFromIndex[i]);
    end;
    FreeAndNil(TS);
  end;
end;

procedure TFormMain.FormGesture(Sender: TObject;
  const EventInfo: TGestureEventInfo; var Handled: Boolean);
begin
{$IFDEF ANDROID}
  case EventInfo.GestureID of
    sgiLeft:
      begin
        if TabControl1.ActiveTab <> TabControl1.Tabs[TabControl1.TabCount - 1]
        then
          TabControl1.ActiveTab := TabControl1.Tabs[TabControl1.TabIndex + 1];
        Handled := True;
      end;

    sgiRight:
      begin
        if TabControl1.ActiveTab <> TabControl1.Tabs[0] then
          TabControl1.ActiveTab := TabControl1.Tabs[TabControl1.TabIndex - 1];
        Handled := True;
      end;
  end;
{$ENDIF}
end;

procedure TFormMain.FormShow(Sender: TObject);
begin
  // El ultiview lo ponemos a oculto
  MultiView1.Mode := TMultiViewMode.Drawer;
  // Las tabs, las ocultamos
  TabControl1.TabPosition := TTabPosition.Dots;
  // Pestaa de info y buscar
  btnAhoraClick(nil);
  btnProxHorasClick(nil);
end;

procedure TFormMain.frHora0Click(Sender: TObject);
begin

end;

// : Obtener la cadena de respuesta formateada.
function TFormMain.GetFormattedResponse(AResponse: String): string;
var
  obj: {$IFDEF DELPHIXE_UP}TJSONObject{$ELSE}TlkJSONobject{$ENDIF};
  vLevel: integer;
begin
  // ini
  Result := STR_EMPTY;
  // vaco?
  if (AResponse = STR_EMPTY) then
  begin
    Exit;
  end;

  obj := TJSONObject.ParseJSONValue(TEncoding.ASCII.GetBytes(AResponse), 0)
    as TJSONObject;
  Result := obj.ToJSON;

end;

function TFormMain.GetLogFileName: string;
begin
  // este me falla
  //  Result := TPath.Combine(TPath.GetSharedDocumentsPath, 'Tiempo.log');
  Result := TPath.Combine(TPath.GetTempPath, 'tiempo.log');
end;

procedure TFormMain.GrabarCiudades;
var
  fName:String;
  I: Integer;
begin

  // Fichero de log y de ciudades
  fName := GetCiudadesFileName();
  // Si esiste, cargamos las ciudades
  if FileExists(fName) then begin
    DeleteFile(fName);
  end;
  for I := 0 to (lbCiudadesDisp.Items.Count - 1) do begin
    CiudadesFile.WriteString('CIUDADES', IntToStr(I), lbCiudadesDisp.Items[I]);
  end;
  CiudadesFile.UpdateFile;
end;

procedure TFormMain.lbCiudadesItemClick(const Sender: TCustomListBox;
  const Item: TListBoxItem);
var
  str:String;
begin
  Str := Item.Text;
  edtNombreCiudad.Text := Str;
  // Aadirla
  lbCiudadesDisp.Items.Add(Str);
  // Cambia de pestaa
  TabControl1.ActiveTab := tsCiudades;

  // limpiar la actual
  edtCiudad.Text := STR_EMPTY;
  lbCiudades.Items.Clear;

  // Grabar las ciudades
  GrabarCiudades;

end;

function TFormMain.GetCiudadesFileName: string;
begin
  Result := TPath.Combine(TPath.GetTempPath, 'ciudades.cfg');
end;

function TFormMain.GetConfigFileName: string;
begin
  Result := TPath.Combine(TPath.GetTempPath, 'tiempo.cfg');
end;


//: recupara la imagen y la guarda en disco
procedure TFormMain.DownloadImage(URLImage:string; APath:string);
var
  Stream:TFileStream;
  IdH:TidHTTP;
  path:string;
  dir:string;
begin
  // Nombre vaco
  if (URLImage = STR_EMPTY) then begin
    Exit;
  end;
  // Crearlo por si no existe
  ForceDirectories(ExtractFilePath(APath));
  try
    // Stream para la imagfen
    Stream  := TFileStream.Create(APath, fmCreate);
    try
      //recuperar la imagen
      IdH := TidHTTP.Create(nil);
      IdH.AllowCookies := True;
      // proteccion
      try
        IdH.Get(Trim(URLImage), Stream);
      except
        // Error al descargar la imagen
        //..  Volcarlo al log
      end;
    finally
      // Liberar
      idH.Free;
      Stream.Free;
    end;
  except
    // error al crear el fichero
    //...  Log
  end;
end;

// actualizar el frame con la informacin
procedure TFormMain.ActualizarFrameHoras(AFrame:TFrameHoras; ATiempoProxHora:TTiempoProxHora);
var
  sIcon, fName, fPath:string;
  bmp:TBitmap;
  sHora, sDia:string;
begin

  // dia y hora
  AFrame.lblDia.Text := FormatDateTime('ddd d', ATiempoProxHora.dt);
  AFrame.lblHora.Text := FormatDateTime('hh:nn', ATiempoProxHora.dt);

  // Tempsraturas
  AFrame.lblTemp.Text := FloatToStrF(ATiempoProxHora.main.temp, ffGeneral, 2, 1) + ' ';
  AFrame.lblMax.Text := FloatToStrF(ATiempoProxHora.Main.tempmax, ffGeneral, 2, 1) + ' ';
  AFrame.lblMin.Text := FloatToStrF(ATiempoProxHora.Main.tempmin, ffGeneral, 2, 1) + ' ';
  _Log('  Valores');

  // Icono...
  sIcon := ATiempoProxHora.weather.icon;
  fName := URL_ICON_PATH + sIcon + '.png';
  // Path de la imagen
  fPath := TPath.Combine(TPath.GetTempPath, sIcon + '.png');
  if (not FileExists(fPath)) then begin
    _Log('   Descargando imagen');
    DownloadImage(fName , fPath);
    _Log('   Imagen descarganda');
  end;
  // Asignarla
  AFrame.img.Bitmap.LoadFromFile(fPath);
end;


procedure TFormMain.ActualizarInfoTiempo(ATiempoProxHoras: TTiempoProxHoras);
var
  i: Integer;
  fr:TFrameHoras;
  comp:TComponent;
begin
  // ini
  i := 0;
  // Nombre de la ciudad
  lblProxHoras.Text := '     Prximas horas...   (' +
                       ATiempoProxHoras.City + ', ' +
                       ATiempoProxHoras.Country + ')';

  // para cada elemento (frames)
  for i := 0 to 15 {Length(ATiempoProxHoras.TiempoHora) - 1} do begin
    // acceder al frame
    comp := FindComponent('frHora' + IntToStr(i));
    // encontrado?
    if Assigned(comp) then begin
      // frame
      fr := TFrameHoras(comp);
      // rellenarlo
      ActualizarFrameHoras(fr, ATiempoProxHoras.TiempoHora[i]);
    end;
  end;
end;


// actulizar en pantalla el tiempo de una ciudad
function TFormMain.ActualizarInfoCiudad(ATiempoObj: TTiempoStruct):boolean;
var
  sIcon, fName, fPath:string;
  bmp:TBitmap;
begin
  _Log('Se va a actualizar la info de la ciudad');
  // ini
  Result := False;

  lblCiudad.Text := ATiempoObj.name;
  lblNuves.Text := ATiempoObj.Weather[0].desc;

  lblTemp.Text := FloatToStrF(ATiempoObj.Main.temp, ffGeneral, 2, 1) + ' ';
  lblTempMax.Text := FloatToStrF(ATiempoObj.Main.tempmax, ffGeneral, 2, 1) + ' ';
  lblTempMin.Text := FloatToStrF(ATiempoObj.Main.tempmin, ffGeneral, 2, 1) + ' ';
  _Log('  Valores');

  // Icono...
  sIcon := ATiempoObj.Weather[0].icon;
  _Log('  sicon');
  fName := URL_ICON_PATH + sIcon + '.png';
  // Descargar imagen
  fPath := TPath.Combine(TPath.GetTempPath, sIcon + '.png');
  _Log('  path: ' + fPath);

  if (not FileExists(fPath)) then begin
    _Log('   Descargando imagen');
    DownloadImage(fName , fPath);
    _Log('   Imagen descarganda');
  end;


  _log('   Cargando la imagen');
  imgTiempo.Bitmap.LoadFromFile(fPath);
  _log('   Imagen cargada');

end;

function GetJSONPairItemFloat(JSONPair:TJSONPair; AValueName:string):Double;
var
  Str:String;
begin
  // ini
  Result:= 0;
  // Buscarlo
  Str := GetJSONPairItemString(JSONPair, AValueName);
  Result := StrToFloatDef(Str, 0);
end;

function GetJSONPairItemString(JSONPair:TJSONPair; AValueName:string):string;
var
  numItems:integer;
  I: Integer;
  oItem:TJSONValue;
  name, Str:String;
begin
  // ini
  Result := '';
  // Elementos existentes
  numItems := TJSONArray(JSONPair.JsonValue).Count;
  // recorrer los que hay
  for I := 0 to (numItems - 1) do begin
    oItem := TJSONArray(JSONPair.JsonValue).Items[I];
    name := TJSONPair(oItem).JsonString.Value;
    // es el que buscamos...
    if (name = AValueName) then begin
      Str := TJSONPair(oItem).JsonValue.Value;
      Result := Str;
      Exit;
    end;
  end;
end;

// Parsea varias horas de tiempo para una ciudad
function TFormMain.ParseTiempoCiudadesHist(AObjResp: TJSONobject; var ATiempoProxHoras: TTiempoProxHoras): Boolean;
var
  i, j, num, index:integer;
  oCityList, oList, oArr:TJSONArray;
  oDatosHora, oCoord, oMain, oWind, oWeather:TJSONobject;
  Str:String;
  oPair, oCity:TJSONPair;
  oItem:TJSONValue;
begin
  _Log('+ ParseTiempoCiudades');
  // ini
  Result := False;
  // Si no est asignado salimos..
  if not Assigned(AobjResp) then begin
  	Exit;
  end;
  // Si hay error no parseamos
	if IsErrorResponse(AObjResp, errCode, ErrMsg) then begin
    _Log('Respuesta de error; ' + ' Code: ' + IntToStr(errCode) + '; Message: ' + ErrMsg);
  	Exit;
  end;
  // proteccion para el parseo
  try
    _Log('INI Parse respuesta.');
    // cod. devuelto (datos principales
    ATiempoProxHoras.Cod := errCode;

    // buscar la ciudad
    oCity := TJSONPair(AObjResp.Get('city'));
    ATiempoProxHoras.City := GetJSONPairItemString(oCity, 'name');
    ATiempoProxHoras.Country := GetJSONPairItemString(oCity, 'country');

    // Parsear lal lista de horas
    oArr := TJSONArray(AObjResp.Get('list').JsonValue);
    num := oArr.size;
    // Si no ha encontrado ninguna, salimos...
    if (num = 0) then begin
      MessageDlg('No hay ninguna ciudad que coincida con ese cdigo <nombre,pais>.', TMsgDlgType.mtWarning, [TMsgDlgBtn.mbOK], 0);
      Exit;
    end;
    // Tamao de array que devolvemos
    Setlength(ATiempoProxHoras.TiempoHora, num);
    // Recorrido por las diferentes horas
    for i := 0 to (num - 1) do begin
      oDatosHora := TJSONObject(oArr.Get(i));

      // fecha/Hora
      ATiempoProxHoras.TiempoHora[i].dt_text := GetAsString(oDatosHora.GetValue('dt_txt').Value);
      Str := ATiempoProxHoras.TiempoHora[i].dt_text;
      // convertir fecha-Hora
      ATiempoProxHoras.TiempoHora[i].dt := EncodeDateTime(
        StrToIntdef(Copy(Str, 1, 4), 0),
        StrToIntdef(Copy(Str, 6, 2), 0),
        StrToIntdef(Copy(Str, 9, 2), 0),
        StrToIntdef(Copy(Str, 12, 2), 0),
        StrToIntdef(Copy(Str, 15, 2), 0),
        StrToIntdef(Copy(Str, 18, 2), 0), 0);
      // Parseo de Main
      oPair := TJSONPair(oDatosHora.Get('main'));
      // Los de main
      ATiempoProxHoras.TiempoHora[i].main.temp := GetJSONPairItemFloat(oPair, 'temp');
      // Los de main
      ATiempoProxHoras.TiempoHora[i].Main.temp := GetJSONPairItemFloat(oPair, 'temp');
      ATiempoProxHoras.TiempoHora[i].Main.tempmin := GetJSONPairItemFloat(oPair, 'temp_min');
      ATiempoProxHoras.TiempoHora[i].Main.tempmax := GetJSONPairItemFloat(oPair, 'temp_max');
      ATiempoProxHoras.TiempoHora[i].Main.pressure := GetJSONPairItemFloat(oPair, 'pressure');
      ATiempoProxHoras.TiempoHora[i].Main.sealevel := GetJSONPairItemFloat(oPair, 'sea_level');
      ATiempoProxHoras.TiempoHora[i].Main.grndlevel := GetJSONPairItemFloat(oPair, 'grnd_level');
      ATiempoProxHoras.TiempoHora[i].Main.humidity := GetJSONPairItemFloat(oPair, 'humidity');
      // weather
      oList := TJSONArray(oDatosHora.Get('weather').JsonValue);
      oWeather := TJSONObject(oList.Get(0));
      ATiempoProxHoras.TiempoHora[i].weather.id := StrToInt(oWeather.GetValue('id').Value);
      ATiempoProxHoras.TiempoHora[i].weather.main := oWeather.GetValue('main').Value;
      ATiempoProxHoras.TiempoHora[i].weather.desc := oWeather.GetValue('description').Value;
      ATiempoProxHoras.TiempoHora[i].weather.icon := oWeather.GetValue('icon').Value;
    end;

    _Log('FINAL parse respuesta');
    Result := True;
  except
		// si hay error, FALSe
    Result := False;
  end;
  _Log('- ParseTiempoCiudades');
end;



procedure TFormMain.ScrollBox1Click(Sender: TObject);
begin

end;

// Parsea la respuesta de varias ciudades a una estructura que nos ha devuelto la web
function TFormMain.ParseTiempoCiudades(AObjResp: TJSONObject;  var ATiempoObj: TTiempoStruct): Boolean;
var
  i, j, num, index:integer;
  oCityList, oList, oArr:TJSONArray;
  oCity, oCoord, oMain, oWind, oWeather:TJSONobject;
  Str:String;
  oPair:TJSONPair;
  oItem:TJSONValue;
begin
  _Log('+ ParseTiempoCiudades');
  // ini
  Result := False;
  // Si no est asignado salimos..
  if not Assigned(AobjResp) then begin
  	Exit;
  end;
  // Si hay error no parseamos
	if IsErrorResponse(AObjResp, errCode, ErrMsg) then begin
    _Log('Respuesta de error; ' + ' Code: ' + IntToStr(errCode) + '; Message: ' + ErrMsg);
  	Exit;
  end;
  // proteccion para el parseo
  try
    _Log('INI Parse respuesta.');
    // cod. devuelto (datos principales
    ATiempoObj.Cod := errCode;
    // Parsear ciudades
    oList := TJSONArray(AObjResp.Get('list').JsonValue);
    num := oList.size;
    // Si no ha encontrado ninguna, salimos...
    if (num = 0) then begin
      MessageDlg('No hay ninguna ciudad que coincida con ese cdigo <nombre,pais>.', TMsgDlgType.mtWarning, [TMsgDlgBtn.mbOK], 0);
      Exit;
    end;
    // Ciudad
    oCity := TJSONObject(oList.Get(0));
    // datos bsicos
    ATiempoObj.id := GetAsInteger(oCity.GetValue('id').Value);
    ATiempoObj.Name := GetAsString(oCity.GetValue('name').Value);
    // Parseo de coordenadas
    oPair := TJSONPair(oCity.Get('coord'));
    oItem := TJSONArray(oPair.JsonValue).Items[0];
    Str := TJSONPair(oItem).JsonValue.Value;
    ATiempoObj.Coord.Lon := StrToFloat(Str);
    oItem := TJSONArray(oPair.JsonValue).Items[1];
    Str := TJSONPair(oItem).JsonValue.Value;
    ATiempoObj.Coord.Lat := StrToFloat(Str);
    // main
    oPair := TJSONPair(oCity.Get('main'));
    // Los de main
    ATiempoObj.Main.temp := GetJSONPairItemFloat(oPair, 'temp');
    ATiempoObj.Main.tempmin := GetJSONPairItemFloat(oPair, 'temp_min');
    ATiempoObj.Main.tempmax := GetJSONPairItemFloat(oPair, 'temp_max');
    ATiempoObj.Main.pressure := GetJSONPairItemFloat(oPair, 'pressure');
    ATiempoObj.Main.sealevel := GetJSONPairItemFloat(oPair, 'sea_level');
    ATiempoObj.Main.grndlevel := GetJSONPairItemFloat(oPair, 'grnd_level');
    ATiempoObj.Main.humidity := GetJSONPairItemFloat(oPair, 'humidity');

    // Viento
    oPair := TJSONPair(oCity.Get('wind'));
    ATiempoObj.Wind.speed := GetJSONPairItemFloat(oPair, 'speed');
    ATiempoObj.Wind.deg := Trunc(GetJSONPairItemFloat(oPair, 'deg'));
    ATiempoObj.Wind.gust := 0;

    // weather
    oList := TJSONArray(oCity.Get('weather').JsonValue);
    SetLength(ATiempoObj.Weather, oList.size);
    oWeather := TJSONObject(oList.Get(0));
    ATiempoObj.Weather[0].id := StrToInt(oWeather.GetValue('id').Value);
    ATiempoObj.Weather[0].main := oWeather.GetValue('main').Value;
    ATiempoObj.Weather[0].desc := oWeather.GetValue('description').Value;
    ATiempoObj.Weather[0].icon := oWeather.GetValue('icon').Value;

    _Log('FINAL parse respuesta');
    Result := True;
  except
		// si hay error, FALSe
    Result := False;
  end;
  _Log('- ParseTiempoCiudades');
end;



procedure TFormMain._Log(AMsg: string);
var
  fName, sTime:String;
  iniF:TIniFile;
  I: Integer;
begin
  fName := GetLogFileName();
  sTime := FormatDateTime('dd/mm/yyyy hh:nn:ss - ', Now);
  mmData.Lines.Add(sTime + AMsg);
  mmData.Lines.Add(sLineBreak);
  mmData.Lines.SaveToFile(fName);

  //--------------------------------------------------
  iniF := TIniFile.Create(fName + '.log');
  for I := 0 to (mmData.Lines.Count - 1) do begin
    IniF.WriteString('DATA', IntToStr(i), mmData.Lines[i]);
  end;
  iniF.UpdateFile;
  iniF.Free;
  //--------------------------------------------------

end;

// Obtener la lista de ciudades de un consulta
function TFormMain.ParseCiudades(AObjResp: TJSONObject; var AListaCiudades: TListaCiudades): Boolean;
var
  I, j: integer;
  oList: TJSONArray;
  oCity, oCoord, oSys: TJSONObject;
  oPair: TJSONPair;
  Str: String;
begin
  // ini
  Result := False;
  AListaCiudades.cont := 0;
  // Si no est asignado salimos..
  if not Assigned(AObjResp) then begin
    Exit;
  end;
  // Si hay error no parseamos
  if IsErrorResponse(AObjResp, errCode, errMsg) then  begin
    Exit;
  end;
  // proteccion para el parseo
  try
    // cod. devuelto (datos principales
    AListaCiudades.cod := errCode;
    // Parsear ciudades
    oList := TJSONArray(AObjResp.Get('list').JsonValue);
    // array de elementos
    SetLength(AListaCiudades.ciudades, oList.size);
    AListaCiudades.cont := oList.size;
    // Para cada ciudad
    for I := 0 to (AListaCiudades.cont - 1) do begin
      oCity := TJSONObject(oList.Get(I));
      // Acceder al resto de datos
      AListaCiudades.ciudades[I].nombre := oCity.GetValue('name').Value;
      oSys := TJSONObject(oCity.Get('sys'));
      Str := AnsiReplaceText(oSys.ToJSON, '"sys":{"country":"', STR_EMPTY);
      Str := AnsiReplaceText(Str, '"}', STR_EMPTY);
      AListaCiudades.ciudades[I].pais := Str;
      // coordenadas
      {oCoord := TJSONObject(oCity.Get('coord'));
      Str := oCoord.GetValue('lat').Value;
      AListaCiudades.ciudades[I].coord.Lat := StrToFloat(Str);
      Str := oCoord.GetValue('lon').Value;
      AListaCiudades.ciudades[I].coord.Lon := StrToFloat(Str);
      }
    end;

    {
      // Parseo de los datos
      //------------------------------------
      AListaCiudades.cont := GetAsInteger(AObjResp.Field['count'].Value);
      // Lista de dias devueltos
      TlkJSONBase(oList) := AObjResp.Field['list'];
      // array de elementos
      SetLength(AListaCiudades.ciudades, oList.Count);
      // Recorrer la lista de objetos.
      for i := 0 to (oList.Count - 1) do begin
      // Datos de la bsicos
      TlkJSONBase(ocity) := oList.Child[i];
      AListaCiudades.ciudades[i].nombre := GetAsString(ocity.Field['name'].Value);

      TlkJSONBase(oSys) := ocity.Field['sys'];
      AListaCiudades.ciudades[i].pais := GetAsString(oSys.Field['country'].Value);

      TlkJSONBase(oCoord) := ocity.Field['coord'];
      AListaCiudades.ciudades[i].coord.Lat := GetAsFloat(oCoord.Field['lat'].Value);
      AListaCiudades.ciudades[i].coord.Lon := GetAsFloat(oCoord.Field['lon'].Value);
      end;
    }

    Result := True;
  except
    // si hay error, FALSe
    Result := False;
  end;
end;


end.
