unit UTWeatherClass;

interface

{$I jedi.inc}

uses
{$IFDEF DELPHIXE_UP}
  JSON, System.SysUtils;
{$ELSE}
  uLkJSON;
{$ENDIF}

type

  TCoord = record
  	Lat:double;
    Lon:double;
  end;

  TCiudad = record
    nombre:string;
    pais:string;
    coord:TCoord;
  end;

  TListaCiudades = record
    cod:integer;
    cont:integer;
    ciudades:array of TCiudad;
  end;

  TSys = record
  	tipo:integer;
  	msg:double;
    country:String;
    sunrise:TDateTime;
    sunset:TDateTime;
  end;

  TWeather = record
  	id:integer;
    main: string;
    desc: string;
    icon: string;
  end;

  // Main para tiempo
  TMain = record
  	temp:double;        // temperatura
    humidity:double;    // humedad %
    pressure:double;
    tempmin:double;
    tempmax:double;
    sealevel:Double;   // atm  presure
    grndlevel:Double;
  end;

  // Viento
  TWind = record
  	speed:double;			// mps
    deg:integer;  		// direccion
    gust:double; 			// rafagas  mps
  end;

  TRain = record
  	Last3h:integer;  // Prec. en mm de las ult. 3 horas
  end;

  TSnow = record
  	Last3h:integer;  // Nieve volumen en mm de las ult. 3 horas
  end;

  TClouds = record
		All:Integer;			// % nublado.
  end;

  TTiempoProxHora = record
    dt:TDateTime;
    dt_text:string;
    main:TMain;
    weather: TWeather;
  end;

  TTiempoProxHoras = record
    Cod:Integer;			// cod. tiempo
    City:string;
    Country:string;
    TiempoHora:array of TTiempoProxHora;
  End;

	TTiempoStruct = record
  	dt:Int64;					// Fecha recepcion
    id:Int64;	  			// id. ciudad
    name:String;			// nombre cioudad
    Base:string;
    Cod:Integer;			// cod. tiempo
  	Coord:TCoord;
    Sys:TSys;
    Weather: array of TWeather;
    Main: TMain;
    Wind:TWind;
    Rain:TRain;
    Clouds:TClouds;
    Snow:TSnow;
  end;

  TCity = record
  	id:integer;
    name:string;
    coord:TCoord;
    country:string;
    population:Integer;
  end;

  TTemp = record
  	day:double;
    min:double;
    max:double;
    night:double;
    eve:double;
    morn:double;
  end;

  TDayForecast = record
  	dt:int64;
		temp:TTemp;
    presure:double;
    humidity:Integer;
    Weather: array of TWeather;
    speed:Double;
    deg:Integer;
    cloud:Integer;
  end;

  TForecastStruct = record
  	cod:string;
    msg:Double;
		city:TCity;
    dayscount:Integer;
    days: array of TDayForecast;
  end;

  // procedimientos y funciones generales
  function IsErrorResponse(AObjResp: {$IFDEF DELPHIXE_UP}TJSONObject{$ELSE}TlkJSONobject{$ENDIF};
  												var ErrCode:Integer; var ErrMessage:string):Boolean;


//=========================================================================
//
// I M P L E M E N T A T I O N
//
//=========================================================================
implementation

uses
	UProcedures;


// procedimientos y funciones generales
function IsErrorResponse(AObjResp:{$IFDEF DELPHIXE_UP}TJSONObject{$ELSE}TlkJSONobject{$ENDIF};
												 var ErrCode:Integer; var ErrMessage:string):Boolean;
var
  str:string;
begin
	// ini
  Result := False;

  Str := AObjResp.GetValue('cod').Value;
  ErrCode:= StrToInt(Str);
  ErrMessage := AObjResp.GetValue('message').Value;

  // Correcto?
  if (ErrCode = 200) then begin
    Result := False;  //todo OK=200
  end
  else begin
    // Buscar el error
    Result := True;
  end;

end;

end.
